﻿Imports System.ComponentModel
Imports System.Data
Imports System.Runtime.CompilerServices

Class MainWindow
    Implements INotifyPropertyChanged

    Private Sub MainWindow_Loaded(sender As Object, e As RoutedEventArgs) Handles Me.Loaded
        Me.DataContext = Me

        PersonDataView = GetPseudoDataTable().AsDataView()
        SelectedPerson = PersonDataView.Item(0)
    End Sub


    Private _personDataView As DataView
    Public Property PersonDataView() As DataView
        Get
            Return _personDataView
        End Get
        Set(ByVal value As DataView)
            _personDataView = value
            RaisePropertyChanged()
        End Set
    End Property


    Private _selectedPerson As DataRowView
    Public Property SelectedPerson() As DataRowView
        Get
            Return _selectedPerson
        End Get
        Set(ByVal value As DataRowView)
            _selectedPerson = value
            RaisePropertyChanged()
        End Set
    End Property


    Private Function GetPseudoDataTable() As DataTable
        Dim dt As New DataTable
        dt.Columns.Add(New DataColumn("FirstName", GetType(String)))
        dt.Columns.Add(New DataColumn("LastName", GetType(String)))
        dt.Columns.Add(New DataColumn("Birthday", GetType(Date)))
        dt.Columns.Add(New DataColumn("Hobbys", GetType(String)))
        dt.Columns.Add(New DataColumn("Address", GetType(String)))

        dt.Rows.Add(CreateDataRow(dt, "Sascha", "Patschka", New Date(1983, 9, 12), "Programmieren, WPF, Klettern, Autos", "2700 Wiener Neustadt"))
        dt.Rows.Add(CreateDataRow(dt, "Max", "Mustermann", New Date(1977, 3, 1), "Formulare ausfüllen, irgendwo Mitglied werden", "12345 Musterstadt"))
        dt.Rows.Add(CreateDataRow(dt, "Susi", "Sorglos", New Date(1999, 1, 19), "Kochen, Städtereisen", "1212 Musterdorf"))
        Return dt
    End Function

    Private Function CreateDataRow(dt As DataTable, firstname As String, lastname As String, birthday As Date, hobbys As String, address As String) As DataRow
        Dim dr As DataRow = dt.NewRow
        dr("FirstName") = firstname
        dr("LastName") = lastname
        dr("Birthday") = birthday
        dr("Hobbys") = hobbys
        dr("Address") = address
        Return dr
    End Function


    Protected Overridable Sub RaisePropertyChanged(<CallerMemberName> Optional ByVal prop As String = "")
        RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(prop))
    End Sub



    Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged
End Class
